// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "SceneItemComponent.hpp"
#include "SceneItem.hpp"
#include "Scene.hpp"
#include "game/DawnGame.hpp"

using namespace Dawn;

SceneItemComponent::SceneItemComponent(SceneItem &item) :
  item(item),
  transform(item.transform)
{
}

Scene & SceneItemComponent::getScene() {
  return this->item.scene;
}

DawnGame & SceneItemComponent::getGame() {
  return this->item.scene.game;
}

SceneItemComponent::~SceneItemComponent() {

}