// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "UIComponent.hpp"
#include "display/mesh/QuadMesh.hpp"
#include "display/font/Font.hpp"

namespace Dawn {
  class UILabel : public UIComponent {
    private:
      Mesh mesh;
      struct FontMeasure measure;
      bool_t needsRebuffering = true;
      Font *font = nullptr;
      std::string text = "";
      float_t fontSize = 10.0f;

      void updateMesh();

    public:
      struct Color textColor = COLOR_MAGENTA;
      
      UILabel(UICanvas &canvas);

      std::string getText();

      void setFont(Font *font);
      void setText(std::string text);
      void setFontSize(float_t fontSize);

      void drawSelf(UIShader &shader, glm::mat4 selfTransform);
  };
}